#ifndef KIND
# define KIND 4
c--# define VERBOSE

      subroutine comp_spline_real(nspc, nrecs,  time, src, drv, spv)
#else
      subroutine comp_spline_double(nspc,nrecs, time, src, drv, spv)
#endif
      implicit none
      integer nspc, nrecs
      real(kind=8) time(nrecs), FC(nrecs), cff
      real(kind=KIND) src(nspc,nrecs), drv(nspc,nrecs), spv
      logical landmask

      integer numthreads,trd, nchunks, chunk_step,chunk_size,
     &              first_ch,last_ch, ichunk, imin,imax, i,j
C$    integer omp_get_num_threads, omp_get_thread_num

      numthreads=1 ; trd=0
C$    numthreads=omp_get_num_threads()
C$    trd=omp_get_thread_num()

      nchunks=max(1,nspc/160)
      i=mod(nchunks,numthreads)
      if (i>0) nchunks=nchunks+numthreads-i
      chunk_step=nchunks/numthreads
      first_ch=trd*chunk_step
      last_ch=first_ch+chunk_step-1

      chunk_size=(nspc + nchunks-1)/nchunks

#ifdef VERBOSE
      write(*,'(1x,A,I6,5(1x,A,I4))')  'comp_spline :: nspc =', nspc,
     &            'chunk_size =',  chunk_size,    'nchunks =', nchunks,
     &            'trd =', trd, 'first =', first_ch, 'last =', last_ch
#endif

#if KIND == 8
      if (spv == 0.0_8) then
#else
      if (spv == 0.0_4) then
#endif
        landmask=.false.
      else
        landmask=.true.
      endif


      do ichunk=first_ch,last_ch
        imin=ichunk*chunk_size +1
        imax=min(imin+chunk_size -1, nspc)


        FC(1)=0.5D0
        do i=imin,imax
          drv(i,1)=1.5D0*(src(i,2)-src(i,1))
        enddo
        do j=2,nrecs-1,+1
          FC(j)=1.D0/(4.D0-FC(j-1))
          cff=FC(j)
          do i=imin,imax
            drv(i,j)=cff*( 3.D0*(src(i,j+1)-src(i,j-1)) -drv(i,j-1))
          enddo
        enddo
        cff=1.D0/(2.D0-FC(nrecs-1))
        do i=imin,imax
          drv(i,nrecs)=cff*( 3.D0*(src(i,nrecs)-src(i,nrecs-1))
     &                                         -drv(i,nrecs-1))
        enddo
        if (landmask) then
          do i=imin,imax
            if (src(i,nrecs) == spv) drv(i,nrecs)=spv
          enddo
        endif

        do j=nrecs-1,1,-1
          cff=FC(j)
          if (landmask) then
            do i=imin,imax
              if (src(i,j) == spv) then
                drv(i,j)=spv
              else
                drv(i,j)=drv(i,j)-cff*drv(i,j+1)
              endif
            enddo
          else
            do i=imin,imax
              drv(i,j)=drv(i,j)-cff*drv(i,j+1)
            enddo
          endif
        enddo

      enddo  !<-- ichunk
      end
#if KIND == 4
# undef KIND
# define KIND 8
# include "comp_spline.F"
#endif
