! A test program for reading GSHHS-style binary files relying on
! Fortran-2003  access='stream' option when opening file. This makes
! reading equivalent to reading from C - no more 4-byte ofsets at the
! start and the end of each record. The idea is read header, which,
! among other things, contains the number of data points in the
! subsequent polygon, then read the polygon itself, hext header, and
! so on.  A single error in record size makes it impossible to find
! the next header.  Note that if everything goes as planned, total
! data read printed at the end should match the size of file in bytes.

      implicit none
      integer(kind=4) id,n,flag, west,east,south,north,
     &                area,area_full,container,ancestor
      integer, allocatable, dimension(:,:) :: Coords
      integer ierr, i, alloc_size
      integer(kind=8) :: read_size=0
      character(len=16) fname
      fname='gshhs_f.b'
c      fname='wdb_rivers_f.b'

      alloc_size=16 ;  allocate(Coords(2,alloc_size))
      open(unit=12, file='coast.dat')
      open(unit=11, file='/opt/gshhs/'/ /fname, form='unformatted',
     &                 access='stream', status='old', iostat=ierr)
      do while(ierr == 0)
        read(11,iostat=ierr) id,n,flag, west,east,south,north,
     &                       area,area_full,container,ancestor
        if (ierr == 0) then
          read_size=read_size+11 

      call swap_i4(id)  ; call swap_i4(west) ; call swap_i4(area)
      call swap_i4(n)   ; call swap_i4(south); call swap_i4(area_full)
      call swap_i4(flag); call swap_i4(east) ; call swap_i4(container)
                          call swap_i4(north); call swap_i4(ancestor)

          write(*,*) 'id =',id, 'n =', n
          if (n > alloc_size) then
            alloc_size=n ; deallocate(Coords) ; allocate(Coords(2,n))
            write(*,*) 'alloc_size =', alloc_size
          endif
          read(11,iostat=ierr) Coords(1:2,1:n)
          if (ierr == 0) then
            read_size=read_size+2*n
            do i=1,n
              call swap_i4(Coords(1,i)) ; call swap_i4(Coords(2,i))
c**           write(12,*) Coords(1:2,i)
            enddo
          endif
        endif
      enddo
      write(*,*) 'total data read =', 4*read_size 
      close(unit=11) ;  close(unit=12)
      end
