      subroutine write_mask(nx,ny, mask, part)
      implicit none
      integer nx,ny, part(4)
      integer(kind=2) :: mask(nx,ny)

      character(len=80) trgname
      integer ncid, r2dgrd(2), varid, ierr, ltrg, lenstr

#include "netcdf.inc"
      trgname='mask.nc' ; ltrg=lenstr(trgname)
      ierr=nf_create(trgname(1:ltrg), nf_64bit_offset, ncid)
      if (ierr == nf_noerr) then
        ierr=nf_def_dim(ncid, 'xi_rho',  nx, r2dgrd(1))
        if (ierr == nf_noerr) then
          ierr=nf_def_dim(ncid, 'eta_rho', ny, r2dgrd(2))
          if (ierr == nf_noerr) then
            if (part(1) /= -1) then
              ierr=nf_put_att_int(ncid, nf_global, 'partition', part)
            endif
            ierr=nf_def_var(ncid, 'land_rho', nf_short, 2,r2dgrd,varid)
            if (ierr == nf_noerr) then
              ierr=nf_enddef(ncid)
              if (ierr == nf_noerr) then
                ierr=nf_put_var_int2(ncid, varid, mask)
                if (ierr == nf_noerr) then
                  ierr=nf_close(ncid)
                  if (ierr == nf_noerr) then
                    write(*,'(/1x,5A/1x,3A/1x,A/)')  'Your land mask ',
     &              'is written as variable ''land_rho'' into netCDF ',
     &              'file ''', trgname(1:ltrg), '''.',  'Inspect it, ',
     &               'then run "copymask" to convert into ROMS-style ',
     &                     'mask and transfer', 'into your grid file.'
                  else
                    write(*,'(/1x,4A/12x,A)')     '### ERROR: Cannot ',
     &                         'close netCDF file ''', trgname(1:ltrg),
     &                                        '''.', nf_strerror(ierr)
                  endif
                else
                  write(*,'(/1x,4A/12x,A)') '### ERROR: Cannot write ',
     &                     'variable ''land_rho'' into netCDF file ''',
     &                      trgname(1:ltrg), '''.', nf_strerror(ierr)

                endif
              else
                write(*,'(/1x,4A/12x,A)') '### ERROR: Cannot switch ',
     &                              'netCDF file ''', trgname(1:ltrg),
     &                       ''' into input mode.', nf_strerror(ierr)
              endif
            else
              write(*,'(/1x,4A/12x,A)')   '### ERROR: Cannot define ',
     &                      'variable ''land_rho'' in netCDF file ''',
     &                      trgname(1:ltrg), '''.', nf_strerror(ierr)
            endif
          else
            write(*,'(/1x,4A/12x,A)')     '### ERROR: Cannot define ',
     &                      'dimension ''eta_rho'' in netCDF file ''',
     &                      trgname(1:ltrg), '''.', nf_strerror(ierr)
          endif
        else
          write(*,'(/1x,4A/12x,A)')       '### ERROR: Cannot define ',
     &                       'dimension ''xi_rho'' in netCDF file ''',
     &                      trgname(1:ltrg), '''.', nf_strerror(ierr)
        endif
      else
        write(*,'(/1x,4A/12x,A)')  '### ERROR: Cannot create netCDF ',
     &          'file ''', trgname(1:ltrg), '''.', nf_strerror(ierr)
      endif
      end
